## org.exist.xquery
Class PathExpr

    java.lang.Object
      org.exist.xquery.AbstractExpression
          org.exist.xquery.PathExpr

All Implemented Interfaces:
  CompiledExpression, CompiledXQuery, Expression

Direct Known Subclasses:
  BinaryOp, EnclosedExpr, Function, Predicate, SequenceConstructor, UnaryExpr

public class PathExpr
extends AbstractExpression
implements CompiledXQuery, CompiledExpression

PathExpr is just a sequence of XQuery/XPath expressions, which will be called step by step.

Author:
  Wolfgang Meier (wolfgang@exist-db.org)

Field Summary

Fields inherited from interface org.exist.xquery.Expression
`DOT_TEST, EXPRESSION_ID_INVALID, IGNORE_CONTEXT, IN_PREDICATE, IN_UPDATE, IN_WHERE_CLAUSE, NO_CONTEXT_ID, SINGLE_STEP_EXECUTION`

Constructor Summary
`PathExpr(XQueryContext context)`

Method Summary
`void` `accept(ExpressionVisitor visitor)` Start traversing the expression tree using the specified `ExpressionVisitor`.
`void` `add(Expression s)` Add an arbitrary expression to this object's list of child-expressions.
`void` `add(PathExpr path)` Add all the child-expressions from another PathExpr to this object's child-expressions.
`void` `addPath(PathExpr path)` Add another PathExpr to this object's expression list.
`void` `addPredicate(Predicate pred)` Add a predicate expression to the list of expressions.
`void` `analyze(AnalyzeContextInfo contextInfo)` Statically analyze the expression and its subexpressions.
`void` `dump(ExpressionDumper dumper)` Write a diagnostic dump of the expression to the passed `ExpressionDumper`.
`void` `dump(java.io.Writer writer)` Writes a diagnostic dump of the expression structure to the specified writer.
`Sequence` `eval(Sequence contextSequence, Item contextItem)` Evaluate the expression represented by this object.
`XQueryAST` `getASTNode()` Returns the `XQueryAST` node from which this expression has been constructed by the parser.
`int` `getCardinality()` The default cardinality is `Cardinality.EXACTLY_ONE`.
`XQueryContext` `getContext()`
`int` `getDependencies()` Returns `Dependency.DEFAULT_DEPENDENCIES`.
`DocumentSet` `getDocumentSet()`
`Expression` `getExpression(int pos)`
`Expression` `getLastExpression()`
`int` `getLength()`
`java.lang.String` `getLiteralValue()`
`XACMLSource` `getSource()` Gets the source of this query.
`boolean` `isValid()` Is the compiled expression still valid? Returns false if, for example, the source code of one of the imported modules has changed.
`void` `replaceLastExpression(Expression s)`
`void` `reset()` Reset the compiled expression tree.
`void` `resetState()` Called to inform an expression that it should reset to its initial state.
`int` `returnsType()` The static return type of the expression.
`void` `setContext(XQueryContext context)`
`void` `setPrimaryAxis(int axis)`
`void` `setSource(XACMLSource source)` Sets the source of this query.
`java.lang.String` `toString()`

Methods inherited from class org.exist.xquery.AbstractExpression
`eval, getContextDocSet, getContextId, getExpressionId, setASTNode, setContextDocSet`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.exist.xquery.CompiledXQuery
`eval`

Constructor Detail

### PathExpr

    public PathExpr(XQueryContext context)

Method Detail

### setSource

    public void setSource(XACMLSource source)

  Description copied from interface: `CompiledXQuery`
  Sets the source of this query.

  Specified by:
    `setSource` in interface `CompiledXQuery`
  Parameters:
    `source` - This query's source

### getSource

    public XACMLSource getSource()

  Description copied from interface: `CompiledXQuery`
  Gets the source of this query.

  Specified by:
    `getSource` in interface `CompiledXQuery`
  Returns:
    This query's source

### add

    public void add(Expression s)

  Add an arbitrary expression to this object's list of child-expressions.

  Parameters:
    `s` -

### add

    public void add(PathExpr path)

  Add all the child-expressions from another PathExpr to this object's child-expressions.

  Parameters:
    `path` -

### addPath

    public void addPath(PathExpr path)

  Add another PathExpr to this object's expression list.

  Parameters:
    `path` -

### addPredicate

    public void addPredicate(Predicate pred)

  Add a predicate expression to the list of expressions. The predicate is added to the last expression in the list.

  Parameters:
    `pred` -

### analyze

    public void analyze(AnalyzeContextInfo contextInfo)
                 throws XPathException

  Description copied from interface: `Expression`
  Statically analyze the expression and its subexpressions. During the static analysis phase, the query engine can detect unknown variables and some type errors.

  Specified by:
    `analyze` in interface `Expression`
  Throws:
    `XPathException`

### eval

    public Sequence eval(Sequence contextSequence,
                         Item contextItem)
                  throws XPathException

  Description copied from interface: `Expression`
  Evaluate the expression represented by this object. Depending on the context in which this expression is executed, either the context sequence, the context item or both of them may be set. An implementing class should know how to handle this. The general contract is as follows: if the `Dependency.CONTEXT_ITEM` bit is set in the bit field returned by `Expression.getDependencies()`, the eval method will be called once for every item in the context sequence. The contextItem parameter will be set to the current item. Otherwise, the eval method will only be called once for the whole context sequence and contextItem will be null. eXist tries to process the entire context set in one, single step whenever possible. Thus, most classes only expect context to contain a list of nodes which represents the current context of the expression. The position() function in XPath is an example for an expression, which requires both, context sequence and context item to be set. The context sequence might be a node set, a sequence of atomic values or a single node or atomic value.

  Specified by:
    `eval` in interface `Expression`
  Specified by:
    `eval` in class `AbstractExpression`
  Throws:
    `XPathException`

### getContext

    public XQueryContext getContext()

  Specified by:
    `getContext` in interface `CompiledXQuery`
  Returns:
    the `XQueryContext` used to create this query

### getDocumentSet

    public DocumentSet getDocumentSet()

### getExpression

    public Expression getExpression(int pos)

### getLastExpression

    public Expression getLastExpression()

### getLength

    public int getLength()

### accept

    public void accept(ExpressionVisitor visitor)

  Description copied from interface: `Expression`
  Start traversing the expression tree using the specified `ExpressionVisitor`.

  Specified by:
    `accept` in interface `Expression`
  Overrides:
    `accept` in class `AbstractExpression`

### dump

    public void dump(ExpressionDumper dumper)

  Description copied from interface: `Expression`
  Write a diagnostic dump of the expression to the passed `ExpressionDumper`.

  Specified by:
    `dump` in interface `Expression`
  Parameters:
    `dumper` - the expression dumper to write to

### toString

    public java.lang.String toString()

### returnsType

    public int returnsType()

  Description copied from interface: `Expression`
  The static return type of the expression. This method should return one of the type constants defined in class `Type`. If the return type cannot be determined statically, return Type.ITEM.

  Specified by:
    `returnsType` in interface `Expression`
  Specified by:
    `returnsType` in class `AbstractExpression`

### getCardinality

    public int getCardinality()

  Description copied from class: `AbstractExpression`
  The default cardinality is `Cardinality.EXACTLY_ONE`.

  Specified by:
    `getCardinality` in interface `Expression`
  Overrides:
    `getCardinality` in class `AbstractExpression`

### getDependencies

    public int getDependencies()

  Description copied from class: `AbstractExpression`
  Returns `Dependency.DEFAULT_DEPENDENCIES`.

  Specified by:
    `getDependencies` in interface `Expression`
  Overrides:
    `getDependencies` in class `AbstractExpression`
  See Also:
    `Expression.getDependencies()`

### replaceLastExpression

    public void replaceLastExpression(Expression s)

### getLiteralValue

    public java.lang.String getLiteralValue()

### getASTNode

    public XQueryAST getASTNode()

  Description copied from interface: `Expression`
  Returns the `XQueryAST` node from which this expression has been constructed by the parser. This node contains location information (line number and column) important for error reports.

  Specified by:
    `getASTNode` in interface `Expression`
  Overrides:
    `getASTNode` in class `AbstractExpression`

### setPrimaryAxis

    public void setPrimaryAxis(int axis)

  Specified by:
    `setPrimaryAxis` in interface `Expression`
  Overrides:
    `setPrimaryAxis` in class `AbstractExpression`

### resetState

    public void resetState()

  Description copied from interface: `Expression`
  Called to inform an expression that it should reset to its initial state. All cached data in the expression object should be dropped. For example, the document() function calls this method whenever the input document set has changed.

  Specified by:
    `resetState` in interface `Expression`
  Overrides:
    `resetState` in class `AbstractExpression`

### reset

    public void reset()

  Description copied from interface: `CompiledXQuery`
  Reset the compiled expression tree. Discard all temporary expression results.

  Specified by:
    `reset` in interface `CompiledXQuery`

### isValid

    public boolean isValid()

  Description copied from interface: `CompiledXQuery`
  Is the compiled expression still valid? Returns false if, for example, the source code of one of the imported modules has changed.

  Specified by:
    `isValid` in interface `CompiledXQuery`

### dump

    public void dump(java.io.Writer writer)

  Description copied from interface: `CompiledXQuery`
  Writes a diagnostic dump of the expression structure to the specified writer.

  Specified by:
    `dump` in interface `CompiledXQuery`

### setContext

    public void setContext(XQueryContext context)

  Specified by:
    `setContext` in interface `CompiledXQuery`

Copyright (C) Wolfgang Meier. All rights reserved.